/*
*  Rubrica
*  file: callbacks.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "modulo.h"
#include "callbacks.h"
#include "prefer.h"
#include "prefer_int.h"
#include "search_int.h"
#include "sort.h"
#include "interface.h"
#include "dialoghi.h"
#include "support.h"
#include "error.h"
#include "file.h"
#include "import.h"
#include "import_int.h"

#include "rubrica.h"

extern GtkWidget *popup;  /* menu popup */

void
on_new_file1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_crea_nuovo_archivio();
}


void	
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_carica_file();
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_salva_file(NULL, NULL);
  rubrica_modificata(FALSE);
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_salva_file_come(NULL,NULL);
  rubrica_modificata(FALSE);
}

void 
esci(void)
{
  gchar *mes;
  gint scelta;
  RubricaPreferences *pref;
  
  pref = rubrica_get_preferences();

  if ((!pref->confirm) && (!rubrica_is_modificata()))
    gtk_main_quit();
  else
    {
    if (rubrica_is_modificata())
      mes = g_strdup(_("Warning. Address book has changed.\nChanges not saved will be loose.\nDo you want continue?"));
    else 
      mes = g_strdup(_("\nDo you want exit rubrica?"));
  
      scelta = confermare_uscita(mes);
      g_free(mes);
      
      switch(scelta)
	{
	case 0:
	  gtk_main_quit();
	  break;
	  
	case 1:
	default:
	  break;
	}  
    }
}


void 
on_import_activate (GtkMenuItem     *menuitem,
		      gpointer         user_data)
{
  GtkWidget *import;
  
  import = create_import_dialog();

  gtk_widget_show(import);
}

void 
on_export_activate (GtkMenuItem     *menuitem,
		      gpointer         user_data)
{
  export_data();
}



void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  esci();
}


void 
on_undo_activate (GtkMenuItem     *menuitem,
		  gpointer         user_data)
{
  /* not yet implemented */
  non_implementato();
}

void
on_redo_activate (GtkMenuItem     *menuitem,
		  gpointer         user_data)
{ /* not yet implemented */
  non_implementato();
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ /* not yet implemented */
  non_implementato();
  
}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ /* not yet implemented */
  non_implementato();

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ /* not yet implemented */
  non_implementato();

}


void
on_pop_cut_activate             (GtkMenuItem     *menuitem,
				 GdkEventButton   *event,
				 gpointer         user_data)
{ /* not yet implemented */
  non_implementato();

}

void
on_pop_paste_activate           (GtkMenuItem     *menuitem,
				 GdkEventButton   *event,
				 gpointer         user_data)
{ /* not yet implemented */
  non_implementato();

}

void
on_pop_copy_activate           (GtkMenuItem     *menuitem,
				GdkEventButton   *event,
				gpointer         user_data)
{ /* not yet implemented */
  non_implementato();

}


void
on_pop_modifica_activate        (GtkMenuItem     *menuitem,
				 gpointer         user_data)

{
  GtkWidget *bot;
  
  bot = get_bModifica();
  gtk_signal_emit_by_name(GTK_OBJECT(bot), "clicked");
}


void
on_alfabetica1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_alfabetico();
  rubrica_riordina_lista();
}


void
on_dimensione1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_grandezza();
  rubrica_riordina_lista();    
}


void
on_data1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_data();
}


void
on_crescente1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_crescente();
  rubrica_riordina_lista();
}


void
on_decrescente1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_decrescente();
  rubrica_riordina_lista();
}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *prop;
  RubricaPreferences *p;

  p = rubrica_get_preferences();
  prop = create_propertybox(p);
  gtk_widget_show(prop);  
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  info();
}


void
on_calabria1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  calabria();
}


void
on_dedicato_a1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  dedica();
}

void 
on_bug_find_activate  (GtkMenuItem     *menuitem,
		       gpointer         user_data)
{ 
  non_implementato();
}

void 
on_goto_rubrica_activate   (GtkMenuItem     *menuitem,
			    gpointer         user_data)
{
  non_implementato();
}

void  
on_write_impression_activate (GtkMenuItem     *menuitem,
			      gpointer         user_data)
{  
  non_implementato();
}  

void
on_bNuovo_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_crea_nuovo_archivio(); 
}


void
on_bApri_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_carica_file();
}


void
on_bSalva_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_salva_file(NULL, NULL);
  rubrica_modificata(FALSE);
}


void
on_bAggiungi_clicked                   (GtkButton       *button,
                                        gpointer         data)
{
  GtkWidget *modulo;
  
  modulo = modulo_rubrica_new(NUOVO_MODULO);
  gtk_widget_show(modulo);
  rubrica_modificata(TRUE);
}


void
on_bElimina_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gint scelta;
  gboolean cancellato;
  GtkCList *clist;
  InfoRubrica info;
  gchar *buffer, *mes;

  clist = rubrica_vista_get_schede();
  rubrica_vista_get_info(&info,VISTA_SCHEDE);

  if (rubrica_is_empty())
    {
      error_rubrica_empty();
      
      return;
    }

  if(!info.selezionato)
    errore_selezionare_elemento();
  else {
    gtk_clist_get_text(GTK_CLIST(clist), info.riga, 1, &buffer);

/*
    mes = g_strdup_printf(_("Sei sicuro di voler eliminare\nla scheda %s?"), buffer);
*/
    mes = g_strdup_printf(_("Do you want delete %s card?"), buffer);
    scelta = confermare_cancellazione(mes);
    g_free(mes);

    switch (scelta)
      {
      case 0:
	cancellato = rubrica_elimina_elemento(info.riga);
	
	if(!cancellato) 
	  /* c' stato un errore, e la scheda non  stata cancellata */
	  errore_cancellazione();
	else {
	  /* la scheda  cancellata, bisogna:
	     -- aggiornare il numero di elementi 
	        (fatto da rubrica_elimina_elemento)
	     -- aggiornare l'elenco delle schede 

	     elimino la scheda n info.riga 
	     e aggiorno la progressbar 	  */
	  rubrica_elimina_scheda(info.riga);
	  rubrica_modificata(TRUE);
	}
	break;
      case 1:   
      default:
	break;
      }    
  }
}



/*  
    Modifica il contenuto di una scheda.
    Funzione richiamata da:
    pressione del bottone modifica sulla toolbar
    doppio click su un elemento della lista
    menu popup - voce modifica
*/
void
on_bModifica_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  InfoRubrica info;
  RubricaItem *r;

  rubrica_vista_get_info(&info, VISTA_SCHEDE);

  if (rubrica_is_empty())
    {
      error_rubrica_empty();

      return;
    }

  if(!info.selezionato)
    errore_selezionare_elemento();

  else {
    r = rubrica_prendi_elemento(info.riga);

    modulo_rubrica_modifica_elemento(r);  
    rubrica_modificata(TRUE);
  }
}


void
on_bPrima_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_mostra_prima_scheda();
}


void
on_bUltima_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_mostra_ultima_scheda();
}


void
on_bCerca_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *search;

  search = create_search_dialog();

  gtk_widget_show(search);
}


void
on_exit_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  esci();
}


void
on_bPrecedente_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_scheda_precedente();
}


void
on_bSuccessivo_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_scheda_successiva();
}


void
on_schede_clist_select_row        (GtkCList        *clist,
				   gint             row,
				   gint             column,
				   GdkEventButton   *e,
				   gpointer         user_data)
{
  InfoRubrica info;

  g_return_if_fail(e != NULL);
  g_return_if_fail(GTK_IS_CLIST(clist));

  info.riga = row;
  info.colonna = column;
  info.selezionato = TRUE;   

  rubrica_vista_set_info(info, VISTA_SCHEDE);
  rubrica_set_scheda_corrente(row);

  /* un solo click
     visualizzare l'elemento e dare all'utente la 
     possibilit di modificare o cancellare l'elemento selezionato

     one click
     show item, the user can modify or delete the selected item
  */
  if (e->type == GDK_BUTTON_RELEASE){
    RubricaItem *r; 
    
    r = rubrica_prendi_elemento(info.riga);
    rubrica_mostra_scheda(r);
    
    return;
  }
  
  /* doppio click
     l'utente deve modificare l'elemento selezionato

     double click 
     user will modify the selected item
  */
  if(e->type == GDK_2BUTTON_PRESS){
    /*  
        RubricaItem *r; 
        
        r = rubrica_prendi_elemento(info.riga);
        rubrica_modifica_elemento(r);
    */
    GtkWidget *bot;
    
    bot = get_bModifica();

    gtk_signal_emit_by_name(GTK_OBJECT(bot), "clicked");
    
    return;
  }
}

void
on_schede_clist_button_click (GtkCList        *clist,
			      GdkEventButton   *event,
			      gpointer         user_data)
{
  gint riga, colonna;
  InfoRubrica info;
  
  g_return_if_fail(GTK_IS_CLIST(clist));
  g_return_if_fail(event != NULL);
  
  
  /* singolo click con il tasto destro del mouse
     visualizzo un menu

     one click with mouse's right button
     show a popup menu
  */ 
  if(event->button == 3)
    {
      /* recupero la riga selezionata */
      gtk_clist_get_selection_info(GTK_CLIST(clist), 
	 			   event->x, event->y, &riga, &colonna);
      /* e la evidenzio */
      gtk_clist_select_row(GTK_CLIST(clist), riga, colonna);

      /* riempio le strutture dati info con i valori relativi alla selezione */
      info.riga = riga;
      info.colonna = colonna;
      info.selezionato = TRUE;   
      
      rubrica_vista_set_info(info, VISTA_SCHEDE);
      rubrica_set_scheda_corrente(riga);     

      /* richiamo il menu poppu */
      gnome_popup_menu_attach(popup,GTK_WIDGET(clist), NULL);
      
      return;
    }
}

/*
  TO DO
  ma sono utili?

  are they usefull, do i really need?
*/

void on_dati_clist_button_click(GtkCList        *clist,
				GdkEventButton   *event,
				gpointer         user_data)
{
  
}



void
on_dati_clist_select_row        (GtkCList        *clist,
				 gint             row,
				 gint             column,
				 GdkEventButton   *event,
				 gpointer         user_data)
{
}

/*  --------------------------------------------------------------- */


/*   click su una colonna della clist

     +----+----+----+
     |    |    |  X<=== click 
     +----+----+----+
     |    |    |    |
     ................
*/
void on_clicked_column_cb(GtkCList *clist,
		       gint column,
		       gpointer user_data)
{
  Ordinamento ord;

  g_return_if_fail(GTK_IS_CLIST(clist));

  ord = rubrica_get_ordinamento();

  /*    per colonna 1, 2, 3
  */
  switch (column)
    {
    case 1:
      rubrica_ordinamento_set_campo(SCHEDA);
      break;
    case 2:
      rubrica_ordinamento_set_campo(NOME);
      break;    
    case 3:      
      rubrica_ordinamento_set_campo(COGNOME);
      break;
    default:
      break;
    }
  if (ord.tipo == CRESCENTE)
    rubrica_ordinamento_set_decrescente();
  else 
    rubrica_ordinamento_set_crescente();      

  rubrica_riordina_lista();
}









