/*
*  Rubrica
*  file: dialoghi.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "dialoghi.h"
#include "support.h"


void
info (void)
{
  const gchar *authors[] = {
   _("Nicola Fragale <nicolafragale@libero.it>"),
   _("\n"),
   _("Dennis Smit, Duch translation"),
    NULL
  };
  GtkWidget *about1;

  about1 = 
    gnome_about_new ("Rubrica", VERSION,
		     _("Copyrigth (C) 2000-2001 Nicola Fragale "),
		     authors,    
		     _("A Gnome Address book\nhttp://digilander.iol.it/nfragale"),
		     "/rubrica/rubrica.jpg");

  gtk_object_set_data (GTK_OBJECT (about1), "about1", about1);
  gtk_container_set_border_width (GTK_CONTAINER (about1), 5);
  gtk_window_set_modal (GTK_WINDOW (about1), TRUE);
  
  gtk_signal_connect (GTK_OBJECT (about1), "clicked",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      NULL);

  gtk_widget_show(about1);
}



void
dedica (void)
{
  GtkWidget *messagebox1;
  GtkWidget *dialog_vbox1;
  GtkWidget *button6;
  GtkWidget *dialog_action_area1;

/*
  messagebox1 = gnome_message_box_new (_("Dedicato a...\n\nla mia mamma\nil mio pap\nla mia fidanzata\ni miei fratelli\ni miei parenti\ni miei amici\n\nun ricordo affettuoso per\nmio zio che non c' pi"),
				       GNOME_MESSAGE_BOX_GENERIC, NULL);
*/
  messagebox1 = gnome_message_box_new (_("This program is dedicate to...\n\nmy mother\nmy father\nmy girl friend\nmy brothers\nmy relatives\nmy friends\n\nan affectionate memory for my uncle\nwho isn't more with us"),
				       GNOME_MESSAGE_BOX_GENERIC, NULL);

  gtk_object_set_data (GTK_OBJECT (messagebox1), "messagebox1", messagebox1);
  gtk_container_set_border_width (GTK_CONTAINER (messagebox1), 6);
  gtk_window_set_modal (GTK_WINDOW (messagebox1), TRUE);
/*  gtk_window_set_title (GTK_WINDOW (messagebox1), _("Informazioni")); */
  gtk_window_set_title (GTK_WINDOW (messagebox1), _("Info"));

  gtk_window_set_position (GTK_WINDOW (messagebox1), GTK_WIN_POS_CENTER);

  dialog_vbox1 = GNOME_DIALOG (messagebox1)->vbox;
  gtk_object_set_data (GTK_OBJECT (messagebox1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (messagebox1), 
			      GNOME_STOCK_BUTTON_OK);
  button6 = g_list_last (GNOME_DIALOG (messagebox1)->buttons)->data;
  gtk_widget_ref (button6);
  gtk_object_set_data_full (GTK_OBJECT (messagebox1), "button6", button6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button6);
  GTK_WIDGET_SET_FLAGS (button6, GTK_CAN_DEFAULT);

  dialog_action_area1 = GNOME_DIALOG (messagebox1)->action_area;
  gtk_widget_ref (dialog_action_area1);
  gtk_object_set_data_full (GTK_OBJECT (messagebox1), "dialog_action_area1",
			    dialog_action_area1,
			    (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_show(messagebox1);
}


void
calabria (void)
{
  GtkWidget *dialogo_calabria;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox1;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;
  GtkWidget *vseparator1;
  GtkWidget *frame_calabria;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button4;

/*  dialogo_calabria = gnome_dialog_new (_("La Calabria"), NULL); */
  dialogo_calabria = gnome_dialog_new (_("Calabria"), NULL);
  gtk_object_set_data (GTK_OBJECT (dialogo_calabria), "dialogo_calabria",
		       dialogo_calabria);
  gtk_container_set_border_width (GTK_CONTAINER (dialogo_calabria), 5);
  gtk_window_set_modal (GTK_WINDOW (dialogo_calabria), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialogo_calabria), FALSE, FALSE, FALSE);
  gnome_dialog_set_close (GNOME_DIALOG (dialogo_calabria), TRUE);

  dialog_vbox1 = GNOME_DIALOG (dialogo_calabria)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialogo_calabria), "dialog_vbox1", 
		       dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialogo_calabria), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox1, TRUE, TRUE, 0);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = 
    gnome_pixmap_file ("rubrica/calabria.xpm");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "calabria.xpm");
  g_free (pixmap1_filename);
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (dialogo_calabria), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (dialogo_calabria), "vseparator1", 
			    vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, FALSE, 5);

/*  frame_calabria = gtk_frame_new (_(" La Calabria ")); */
  frame_calabria = gtk_frame_new (_(" Calabria "));
  gtk_widget_ref (frame_calabria);
  gtk_object_set_data_full (GTK_OBJECT (dialogo_calabria), "frame_calabria",
			    frame_calabria, 
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_calabria);
  gtk_box_pack_start (GTK_BOX (hbox1), frame_calabria, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_calabria), 5);

  label1 = gtk_label_new (_("\"\n\t\t\tQuando fu il giorno della Calabria, Dio si trov in pugno 15.000 chilometri quadrati di argilla verde con riflessi viola. Il Signore promise a Se Stesso di farne un capolavoro e la Calabria usc dalle Sue mani pi bella della California e delle Haway, pi bella della Costa Azzurra e degli Arcipelaghi giapponesi. Diede alla Sila il pino, all'Aspromonte l'ulivo, a Rosarno l'arancio, a Scilla le Sirene, a Bagnara i pergolati, allo scoglio il lichene, all'onda il riflesso del sole, alla roccia l'oleastro, a Gioia l'olio, a Cosenza l'Accademia, a Catanzaro il damasco, a Reggio il bergamotto, allo Stretto il pescespada. Poi distribu i mesi e le stagioni alla Calabria. Per l'inverno le fu concesso il sole, per la primavera il sole, per l'autunno il sole...\nA gennaio diede la castagna, a febraio la pignolata, a marzo la ricotta, ad aprile la focaccia con l'uovo, a maggio il pescespada, a giugno la ciliegia, a luglio il ficomelanzano, ad agosto lo zibibbo, a settembre il ficodindia, ad ottobre la mostarda, a novembre la noce, a dicembre l'arancia. Volle il mare sempre viola, la rosa sbocciante a dicembre, il cielo terso, le campagne fertili, le messi pingui, il clima mite, il profumo delle erbe inebriante...\t\t\"\n\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tLeonida Rpaci\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t Rubbettino Editore\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t http://www.rubbettino.it\n"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialogo_calabria), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_container_add (GTK_CONTAINER (frame_calabria), label1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);
  gtk_misc_set_padding (GTK_MISC (label1), 15, 2);

  dialog_action_area1 = GNOME_DIALOG (dialogo_calabria)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialogo_calabria), "dialog_action_area1",
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), 
			     GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (dialogo_calabria), 
			      GNOME_STOCK_BUTTON_OK);
  button4 = g_list_last (GNOME_DIALOG (dialogo_calabria)->buttons)->data;
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (dialogo_calabria), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);

  gtk_widget_show(dialogo_calabria);
}


gint confermare_cancellazione(gchar *messaggio)
{
  GtkWidget *dialogo, *label;
  gint bottone;

/*  dialogo = gnome_dialog_new(_("Attenzione"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);
*/
  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);
  label = gtk_label_new(messaggio);
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, 
		     TRUE, 0);
  
  bottone = gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));

  return bottone;
}


gint confermare_uscita(gchar *messaggio)
{
  GtkWidget *dialogo, *label;
  gint bottone;

/*  dialogo = gnome_dialog_new(_("Attenzione"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);
*/
  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);  
  label = gtk_label_new(messaggio);
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, 
		     TRUE, 0);
  
  bottone = gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));

  return bottone;
}
