/*
*  Rubrica
*  file: file.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_FILE_H
#define __RUBRICA_FILE_H

#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>

#include "rubrica.h"
#include "modulo.h"
#include "error.h"
#include "dialoghi.h"

void rubrica_init_archivio(void);
void rubrica_file_set_names(gchar *pathfile, gchar *filename);

void rubrica_file_init_names(void);
void rubrica_crea_nuovo_archivio(void);


void rubrica_salva_file(GtkWidget *w, gpointer data);
void rubrica_salva_file_come(GtkWidget *w, gpointer data);
gboolean write_xml_file(gchar *fname);
void rubrica_scrivi_file(GtkWidget *w, GtkFileSelection *fs);
void rubrica_write_elemento_to_xml(xmlNodePtr xmlnode, RubricaItem *);
  
gboolean rubrica_file_has_extension(gchar *fn);
void rubrica_do_backup(gchar *old, gchar *new);
void rubrica_file_split(gchar *file, gchar *f, gchar *ext, gint *n);

void rubrica_carica_file();
void rubrica_apri_file(GtkWidget *w, GtkFileSelection *fs);
gboolean read_xml_file(gchar *fname);
void parse_doc(xmlDocPtr doc);
void rubrica_load_elemento_from_xml(xmlNodePtr xmlnode, GList *l);

void rubrica_apri_old_file(gchar *fname);
gboolean read_old_xml_file(gchar *fname);
void parse_old_doc(xmlDocPtr doc);
void rubrica_load_element_from_old_xml(xmlNodePtr xmlnode, GList *l);

#endif __RUBRICA_FILE_H
