/*
*  Rubrica
*  file: import.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _IMPORT_H
#define _IMPORT_H

#include "rubrica.h"

typedef enum {
  GTOKEN = 1,
  KTOKEN
} TypeToken;

typedef enum {
  CSV = 0,
  GCARD,
  KCARD,
  RUBRICA
} ImportFrom;

typedef enum {
  BEGIN = 0,
  FN,   N,
  REV,
  BDAY,
  ADR,  TEL,  EMAIL, URL, TZ, GEO,
  TITLE,  ORG, 
  CATEGORIES,  NOTE,
  KEY,
  Entries,
  additionalName, address, town, country, zip, birthday,
  comment, deliveryLabel, 
  email, email2, email3, emails, 
  fax, modem, 
  firstname, fn, name, namePrefix, title, 
  keywords, org, orgSubUnit, orgUnit, role, 
  state, talk, 
  telephone,   
  END,
  BAD
} TokenKGCard;

typedef enum {
  VCARD = 0,
  HOME,  WORK, POSTAL, PARCEL, DOM, INTL, PREF,
  VOICE, FAX, MSG, CELL, PAGER, BBS, MODEM, CAR, ISDN, VIDEO,  
  AOL, INTERNET, APPLELINK, ATTMAIL, CIS, EWORLD, IBMMail, MCIMAIL, 
  POWERSHARE, PRODIGY, TLX, X400, PGP, X509, 
  NO_SUB,  SUB_END
} SubGToken;


typedef struct _token {
  gchar *str;
  TokenGCard tok;
  TypeToken token_type;
  gboolean subtok;
} Token;

typedef struct _subtoken {
  gchar *str;
  SubGToken stok;
} SubGtoken;


void import_init_item(RubricaItem *r);

void import_data(void);
void export_data(void);
TokenGCard get_token(gchar *tkbuf);

void rubrica_import_open_file(gchar *file);

void rubrica_decode_buffer(gchar *buf);

TokenGCard decode_gtoken(gchar *str, SubGToken *st);
SubGToken decode_gsubtoken(gchar *str);

void import_from_init(void);
void import_from_set(ImportFrom imp);
ImportFrom import_from_get(void);

void import_free_note(GList *n);
gchar *import_decode_note(GList *l);


gchar *import_get_string(gchar *buf);
void import_decode_string(char *buf, gchar *dec[7]);

gint rubrica_import_open_rubrica_old_file(gchar *fname);
#endif
