/*
*  Rubrica
*  file: prefer.h
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_PREF_H
#define _RUBRICA_PREF_H


// typedef enum {
//  NEVER = 0,
//  ALWAYS,
//  ALL_PATH,       /* show file's path */
//  ONLY_FILE,      /* show only filename */
//  ALPHA,          /* show card in alphabetic order */
//  DATE,           /* show card by date */
//  INCREASING,     /* mode: increasing */
//  DECREASINg      /* mode: decreasing */  
// } 


typedef struct _RubricaPreferences {
  gboolean show_file;
  gboolean default_addressbook;
  gboolean alpha;
  gboolean date;
  gboolean increasing;
  gboolean confirm;
  gboolean backup;

  gchar *default_path;
  gchar *default_filename;  
  gchar *user_path;
  gchar *user_filename;
} RubricaPreferences;


void rubrica_preferences_init();

gint rubrica_preferences_save(void);
gint rubrica_preferences_load(RubricaPreferences *p);
RubricaPreferences *rubrica_get_preferences();

void rubrica_pref_set_file_show(gboolean show_file);
void rubrica_pref_set_default_addressbook(gboolean default_ab);
void rubrica_pref_set_alpha_order(gboolean ord);
void rubrica_pref_set_date_order(gboolean ord);
void rubrica_pref_set_exit_confirm(gboolean confirm);
void rubrica_pref_set_increasing(gboolean inc);
void rubrica_pref_set_do_backup(gboolean bk);

gboolean prefer_get_bool(gchar *buf);
gchar *prefer_get_str(gchar *buf);
gint prefer_get_int(gchar *buf);

#endif

