/*
*  Rubrica
*  file: prefer_cb.c
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "prefer.h"
#include "prefer_cb.h"
#include "prefer_int.h"
#include "support.h"


void
on_propertybox_apply                  (GnomePropertyBox *gnomepropertybox,
				       gint             arg1,
				       gpointer         user_data)
{
  rubrica_preferences_save();
}


void
on_radio_show_file_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_file_show(TRUE);  
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_show_path_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_file_show(FALSE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_check_default_toggled                (GtkToggleButton *togglebutton,
					 gpointer         user_data)
{
  rubrica_pref_set_default_addressbook(TRUE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_alfa_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_alpha_order(TRUE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_data_toggled                (GtkToggleButton *togglebutton,
                                      gpointer         user_data)
{
  rubrica_pref_set_date_order(TRUE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_increase_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_increasing(TRUE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_decrease_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_increasing(FALSE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_backup_never_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_do_backup(FALSE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_backup_always_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_do_backup(TRUE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}

void
on_radio_confirm_no_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_exit_confirm(FALSE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}


void
on_radio_confirm_yes_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_pref_set_exit_confirm(TRUE);
  gnome_property_box_changed(GNOME_PROPERTY_BOX(user_data));
}
